## simdutf 7.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

project(simdutf
  DESCRIPTION "Fast Unicode validation, transcoding and processing"
  LANGUAGES CXX
  VERSION 7.4.0
)

include (TestBigEndian)
TEST_BIG_ENDIAN(IS_BIG_ENDIAN)
if(IS_BIG_ENDIAN)
  message(STATUS "Big-endian system detected.")
endif()

include(GNUInstallDirs)
# The following requires CMake 3.21.
# if(PROJECT_IS_TOP_LEVEL)
#  message(STATUS "Building simdutf as a top-level project.")
#  include(CTest)
#else()
#  message(STATUS "Building simdutf as a subproject.")
#endif(PROJECT_IS_TOP_LEVEL)
include(CTest)
include(cmake/simdutf-flags.cmake)

set(SIMDUTF_LIB_VERSION "26.0.0" CACHE STRING "simdutf library version")
set(SIMDUTF_LIB_SOVERSION "26" CACHE STRING "simdutf library soversion")
option(SIMDUTF_TESTS "Whether the tests are included as part of the CMake Build." ON)
option(SIMDUTF_ATOMIC_BASE64_TESTS "Whether to test the atomic base64 functions. (OFF by default)" OFF)
option(SIMDUTF_BENCHMARKS "Whether the benchmarks are included as part of the CMake Build." OFF)
option(SIMDUTF_TOOLS "Whether the tools are included as part of the CMake build. Requires C++17 or better." ON)
option(SIMDUTF_ICONV "Whether to use iconv as part of the CMake build if available." ON)
option(SIMDUTF_FUZZERS "Whether to build the fuzzers." OFF)
option(SIMDUTF_COVERAGE "Enable code coverage collection during tests (only GCC and Clang)." OFF)
option(SIMDUTF_INTERNAL_TESTS "Whether to test also internal procedures. Useful mostly for developers, not users." OFF)
option(SIMDUTF_LOGGING "Whether to enable logging (this should never be used in binary releases)." OFF)
option(FUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION "Whether to enable unsafe fuzzing mode." OFF)
if(SIMDUTF_LOGGING AND DEFINED CMAKE_CXX_STANDARD AND CMAKE_CXX_STANDARD LESS 17)
    set(CMAKE_CXX_STANDARD 17)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()
set(SIMDUTF_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})

add_subdirectory(src)
add_subdirectory(singleheader)

if (SIMDUTF_TESTS)
  message(STATUS "The tests are enabled.")
  add_subdirectory(tests)
else(SIMDUTF_TESTS)
  message(STATUS "The tests are disabled.")
endif(SIMDUTF_TESTS)


if (SIMDUTF_TOOLS)
  if(CMAKE_CXX_COMPILER_ID MATCHES GNU AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8.0)
    message(STATUS "The benchmark tool requires GCC 8.0 or better.")
  else()
    add_subdirectory(tools)
  endif()
endif()


if (SIMDUTF_BENCHMARKS)
  if(NOT SIMDUTF_TESTS)
    message(STATUS "You have enabled the benchmarks, but not the tests. We don't allow running the benchmarks without the tests.")
  elseif((CMAKE_CXX_COMPILER_ID MATCHES GNU) AND (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "8.0"))
    message(STATUS "The benchmark tool requires GCC 8.0 or better.")
  else()
    message(STATUS "The benchmarks can be disabled by setting SIMDUTF_BENCHMARKS, e.g., -D SIMDUTF_BENCHMARKS=OFF.")
    add_subdirectory(benchmarks)
  endif()
else()
  message(STATUS "The benchmarks can be enabled by setting SIMDUTF_BENCHMARKS, e.g., -D SIMDUTF_BENCHMARKS=ON.")
endif()

if (SIMDUTF_COVERAGE)
  if (NOT SIMDUTF_TESTS)
    message(FATAL_ERROR "Cannot enable code coverage without tests (enable SIMDUTF_TESTS option)")
  endif()
  if (NOT ((CMAKE_CXX_COMPILER_ID MATCHES "GNU") OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang")))
    message(FATAL_ERROR "Code coverage is supported only by GCC and Clang")
  endif()
  message(STATUS "Code coverage enabled; use `ctest -T Test -T Coverage` to gather coverage details")
endif()

message(STATUS "Compiling using the C++ standard:" ${CMAKE_CXX_STANDARD})
# ---- Install rules ----
add_library(simdutf::simdutf ALIAS simdutf)

set_target_properties(
    simdutf PROPERTIES
    VERSION "${SIMDUTF_LIB_VERSION}"
    SOVERSION "${SIMDUTF_LIB_SOVERSION}"
    WINDOWS_EXPORT_ALL_SYMBOLS YES
)

include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

install(
    FILES include/simdutf.h
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
    COMPONENT simdutf_Development
)

install(
    DIRECTORY include/simdutf
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
    COMPONENT simdutf_Development
)

install(
    TARGETS simdutf
    EXPORT simdutfTargets
    RUNTIME COMPONENT simdutf_Runtime
    LIBRARY COMPONENT simdutf_Runtime
    NAMELINK_COMPONENT simdutf_Development
    ARCHIVE COMPONENT simdutf_Development
    INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
)

configure_file(cmake/simdutf-config.cmake.in simdutf-config.cmake @ONLY)

write_basic_package_version_file(
    simdutf-config-version.cmake
    COMPATIBILITY SameMinorVersion
)

set(
    SIMDUTF_INSTALL_CMAKEDIR "${CMAKE_INSTALL_LIBDIR}/cmake/simdutf"
    CACHE STRING "CMake package config location relative to the install prefix"
)
mark_as_advanced(SIMDUTF_INSTALL_CMAKEDIR)

install(
    FILES
    "${PROJECT_BINARY_DIR}/simdutf-config.cmake"
    "${PROJECT_BINARY_DIR}/simdutf-config-version.cmake"
    DESTINATION "${SIMDUTF_INSTALL_CMAKEDIR}"
    COMPONENT simdutf_Development
)

install(
    EXPORT simdutfTargets
    NAMESPACE simdutf::
    DESTINATION "${SIMDUTF_INSTALL_CMAKEDIR}"
    COMPONENT example_Development
)


# pkg-config
include(cmake/JoinPaths.cmake)
join_paths(PKGCONFIG_INCLUDEDIR "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}")
join_paths(PKGCONFIG_LIBDIR "\${prefix}" "${CMAKE_INSTALL_LIBDIR}")

configure_file("simdutf.pc.in" "simdutf.pc" @ONLY)
install(
    FILES "${CMAKE_CURRENT_BINARY_DIR}/simdutf.pc"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)
#
# CPack
#
if(is_top_project)
  set(CPACK_PACKAGE_VENDOR "Daniel Lemire")
  set(CPACK_PACKAGE_CONTACT "lemire@gmail.com")
  set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE-MIT")
  set(CPACK_RPM_PACKAGE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE-MIT")
  set(CPACK_RESOURCE_FILE_README "${PROJECT_SOURCE_DIR}/README.md")
  set(CPACK_SOURCE_GENERATOR "TGZ;ZIP")
  include(CPack)
endif()

# ----



if(SIMDUTF_TESTS AND NOT SIMDUTF_SANITIZE)
  find_program(GREP grep)
  find_program(NM nm)
  if((NOT GREP) OR (NOT NM))
    message("grep and nm are unavailable on this system.")
  else()
    add_test(
      NAME "avoid_abort"
      # Under FreeBSD, the __cxa_guard_abort symbol may appear but it is fine.
      # So we want to look for <space><possibly _>abort as a test.
      COMMAND sh -c "${NM}  $<TARGET_FILE_NAME:simdutf> |  ${GREP} ' _*abort' || exit 0  && exit 1"
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    )
    add_test(
      NAME "avoid_cout"
      COMMAND sh -c "${NM}  $<TARGET_FILE_NAME:simdutf> |  ${GREP} ' _*cout' || exit 0  && exit 1"
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    )
    add_test(
      NAME "avoid_cerr"
      COMMAND sh -c "${NM}  $<TARGET_FILE_NAME:simdutf> |  ${GREP} ' _*cerr' || exit 0  && exit 1"
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    )
    add_test(
      NAME "avoid_printf"
      COMMAND sh -c "${NM}  $<TARGET_FILE_NAME:simdutf> |  ${GREP} ' _*printf' || exit 0  && exit 1"
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    )
    add_test(
      NAME "avoid_stdout"
      COMMAND sh -c "${NM}  $<TARGET_FILE_NAME:simdutf> |  ${GREP} stdout || exit 0 && exit 1"
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    )
    add_test(
      NAME "avoid_stderr"
      COMMAND sh -c "${NM}  $<TARGET_FILE_NAME:simdutf> |  ${GREP} stderr || exit 0 && exit 1"
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    )
  endif()
endif()

if(SIMDUTF_FUZZERS)
    add_subdirectory(fuzz)
endif()

=== tests/helpers/CMakeLists.txt ===
add_library(simdutf_tests_helpers STATIC
  test.h
  test.cpp
  random_int.h
  random_int.cpp
  transcode_test_base.h
  transcode_test_base.cpp
  random_utf8.h
  random_utf8.cpp
  random_utf16.h
  random_utf16.cpp
  random_utf32.h
  random_utf32.cpp)
target_include_directories(simdutf_tests_helpers PUBLIC ${SIMDUTF_TEST_INCLUDE_DIR})
target_link_libraries(simdutf_tests_helpers PUBLIC simdutf simdutf::tests::reference)

add_library(simdutf::tests::helpers ALIAS simdutf_tests_helpers)

=== tests/reference/CMakeLists.txt ===
add_library(simdutf_tests_reference STATIC
  encode_utf8.h
  encode_utf8.cpp
  encode_utf16.h
  encode_utf16.cpp
  encode_utf32.h
  encode_utf32.cpp
  encode_latin1.h
  encode_latin1.cpp
  validate_utf8_to_latin1.h
  validate_utf8_to_latin1.cpp
  validate_utf16_to_latin1.h
  validate_utf16_to_latin1.cpp
  validate_utf32_to_latin1.h
  validate_utf32_to_latin1.cpp
  validate_utf8.h
  validate_utf8.cpp
  validate_utf16.h
  validate_utf16.cpp
  validate_utf32.h
  validate_utf32.cpp)
add_library(simdutf::tests::reference ALIAS simdutf_tests_reference)
target_link_libraries(simdutf_tests_reference PRIVATE simdutf)

=== debian/changelog ===
simdutf (7.4.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1096008)

 -- Mo Zhou <lumin@debian.org>  Mon, 13 Oct 2025 07:59:32 -0400

=== debian/control ===
Source: simdutf
Section: libs
Homepage: https://github.com/simdutf/simdutf
Priority: optional
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/debian/simdutf.git
Vcs-Browser: https://salsa.debian.org/debian/simdutf
Maintainer: Mo Zhou <lumin@debian.org>
Build-Depends: debhelper-compat (= 13), cmake, python3,

Package: libsimdutf-dev
Architecture: any
Section: libdevel
Depends: libsimdutf26 (= ${binary:Version}),
	 ${misc:Depends}
Description: Fast Unicode validation and transcoding - development files
 Most modern software relies on the Unicode standard. In memory, Unicode
 strings are represented using either UTF-8 or UTF-16. The UTF-8 format is the
 de facto standard on the web (JSON, HTML, etc.) and it has been adopted as the
 default in many popular programming languages (Go, Zig, Rust, Swift, etc.).
 The UTF-16 format is standard in Java, C# and in many Windows technologies.
 .
 Not all sequences of bytes are valid Unicode strings. It is unsafe to use
 Unicode strings in UTF-8 and UTF-16LE without first validating them.
 Furthermore, we often need to convert strings from one encoding to another, by
 a process called transcoding. For security purposes, such transcoding should
 be validating: it should refuse to transcode incorrect strings.
 .
 This library provide fast Unicode functions such as
 .
  * ASCII, UTF-8, UTF-16LE/BE and UTF-32 validation, with and without error
    identification,
  * Latin1 to UTF-8 transcoding,
  * Latin1 to UTF-16LE/BE transcoding
  * Latin1 to UTF-32 transcoding
  * UTF-8 to Latin1 transcoding, with or without validation, with and without
    error identification,
  * UTF-8 to UTF-16LE/BE transcoding, with or without validation, with and
    without error identification,
  * UTF-8 to UTF-32 transcoding, with or without validation, with and without
    error identification,
  * UTF-16LE/BE to Latin1 transcoding, with or without validation, with and
    without error identification,
  * UTF-16LE/BE to UTF-8 transcoding, with or without validation, with and
    without error identification,
  * UTF-32 to Latin1 transcoding, with or without validation, with and without
    error identification,
  * UTF-32 to UTF-8 transcoding, with or without validation, with and without
    error identification,
  * UTF-32 to UTF-16LE/BE transcoding, with or without validation, with and
    without error identification,
  * UTF-16LE/BE to UTF-32 transcoding, with or without validation, with and
    without error identification,
  * From an UTF-8 string, compute the size of the Latin1 equivalent string,
  * From an UTF-8 string, compute the size of the UTF-16 equivalent string,
  * From an UTF-8 string, compute the size of the UTF-32 equivalent string
    (equivalent to UTF-8 character counting),
  * From an UTF-16LE/BE string, compute the size of the Latin1 equivalent
    string,
  * From an UTF-16LE/BE string, compute the size of the UTF-8 equivalent
    string,
  * From an UTF-32 string, compute the size of the UTF-8 or UTF-16LE equivalent
    string,
  * From an UTF-16LE/BE string, compute the size of the UTF-32 equivalent
    string (equivalent to UTF-16 character counting),
  * UTF-8 and UTF-16LE/BE character counting,
  * UTF-16 endianness change (UTF16-LE/BE to UTF-16-BE/LE),
  * WHATWG forgiving-base64 (with or without URL encoding) to binary,
  * Binary to base64 (with or without URL encoding).
 .
 The functions are accelerated using SIMD instructions (e.g., ARM NEON, SSE,
 AVX, AVX-512, RISC-V Vector Extension, LoongSon, POWER, etc.). When your
 strings contain hundreds of characters, we can often transcode them at speeds
 exceeding a billion characters per second. You should expect high speeds not
 only with English strings (ASCII) but also Chinese, Japanese, Arabic, and so
 forth. We handle the full character range (including, for example, emojis).
 .
 The library compiles down to a small library of a few hundred kilobytes. Our
 functions are exception-free and non allocating. We have extensive tests and
 extensive benchmarks.
 .
 This package ships the development files.

Package: libsimdutf26
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Fast Unicode validation and transcoding
 Most modern software relies on the Unicode standard. In memory, Unicode
 strings are represented using either UTF-8 or UTF-16. The UTF-8 format is the
 de facto standard on the web (JSON, HTML, etc.) and it has been adopted as the
 default in many popular programming languages (Go, Zig, Rust, Swift, etc.).
 The UTF-16 format is standard in Java, C# and in many Windows technologies.
 .
 Not all sequences of bytes are valid Unicode strings. It is unsafe to use
 Unicode strings in UTF-8 and UTF-16LE without first validating them.
 Furthermore, we often need to convert strings from one encoding to another, by
 a process called transcoding. For security purposes, such transcoding should
 be validating: it should refuse to transcode incorrect strings.
 .
 This library provide fast Unicode functions such as
 .
  * ASCII, UTF-8, UTF-16LE/BE and UTF-32 validation, with and without error
    identification,
  * Latin1 to UTF-8 transcoding,
  * Latin1 to UTF-16LE/BE transcoding
  * Latin1 to UTF-32 transcoding
  * UTF-8 to Latin1 transcoding, with or without validation, with and without
    error identification,
  * UTF-8 to UTF-16LE/BE transcoding, with or without validation, with and
    without error identification,
  * UTF-8 to UTF-32 transcoding, with or without validation, with and without
    error identification,
  * UTF-16LE/BE to Latin1 transcoding, with or without validation, with and
    without error identification,
  * UTF-16LE/BE to UTF-8 transcoding, with or without validation, with and
    without error identification,
  * UTF-32 to Latin1 transcoding, with or without validation, with and without
    error identification,
  * UTF-32 to UTF-8 transcoding, with or without validation, with and without
    error identification,
  * UTF-32 to UTF-16LE/BE transcoding, with or without validation, with and
    without error identification,
  * UTF-16LE/BE to UTF-32 transcoding, with or without validation, with and
    without error identification,
  * From an UTF-8 string, compute the size of the Latin1 equivalent string,
  * From an UTF-8 string, compute the size of the UTF-16 equivalent string,
  * From an UTF-8 string, compute the size of the UTF-32 equivalent string
    (equivalent to UTF-8 character counting),
  * From an UTF-16LE/BE string, compute the size of the Latin1 equivalent
    string,
  * From an UTF-16LE/BE string, compute the size of the UTF-8 equivalent
    string,
  * From an UTF-32 string, compute the size of the UTF-8 or UTF-16LE equivalent
    string,
  * From an UTF-16LE/BE string, compute the size of the UTF-32 equivalent
    string (equivalent to UTF-16 character counting),
  * UTF-8 and UTF-16LE/BE character counting,
  * UTF-16 endianness change (UTF16-LE/BE to UTF-16-BE/LE),
  * WHATWG forgiving-base64 (with or without URL encoding) to binary,
  * Binary to base64 (with or without URL encoding).
 .
 The functions are accelerated using SIMD instructions (e.g., ARM NEON, SSE,
 AVX, AVX-512, RISC-V Vector Extension, LoongSon, POWER, etc.). When your
 strings contain hundreds of characters, we can often transcode them at speeds
 exceeding a billion characters per second. You should expect high speeds not
 only with English strings (ASCII) but also Chinese, Japanese, Arabic, and so
 forth. We handle the full character range (including, for example, emojis).
 .
 The library compiles down to a small library of a few hundred kilobytes. Our
 functions are exception-free and non allocating. We have extensive tests and
 extensive benchmarks.
 .
 This package ships the shared object.

Package: libsimdutf-tools
Architecture: any
Section: misc
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Fast Unicode validation and transcoding - utilities
 Most modern software relies on the Unicode standard. In memory, Unicode
 strings are represented using either UTF-8 or UTF-16. The UTF-8 format is the
 de facto standard on the web (JSON, HTML, etc.) and it has been adopted as the
 default in many popular programming languages (Go, Zig, Rust, Swift, etc.).
 The UTF-16 format is standard in Java, C# and in many Windows technologies.
 .
 Not all sequences of bytes are valid Unicode strings. It is unsafe to use
 Unicode strings in UTF-8 and UTF-16LE without first validating them.
 Furthermore, we often need to convert strings from one encoding to another, by
 a process called transcoding. For security purposes, such transcoding should
 be validating: it should refuse to transcode incorrect strings.
 .
 This library provide fast Unicode functions such as
 .
  * ASCII, UTF-8, UTF-16LE/BE and UTF-32 validation, with and without error
    identification,
  * Latin1 to UTF-8 transcoding,
  * Latin1 to UTF-16LE/BE transcoding
  * Latin1 to UTF-32 transcoding
  * UTF-8 to Latin1 transcoding, with or without validation, with and without
    error identification,
  * UTF-8 to UTF-16LE/BE transcoding, with or without validation, with and
    without error identification,
  * UTF-8 to UTF-32 transcoding, with or without validation, with and without
    error identification,
  * UTF-16LE/BE to Latin1 transcoding, with or without validation, with and
    without error identification,
  * UTF-16LE/BE to UTF-8 transcoding, with or without validation, with and
    without error identification,
  * UTF-32 to Latin1 transcoding, with or without validation, with and without
    error identification,
  * UTF-32 to UTF-8 transcoding, with or without validation, with and without
    error identification,
  * UTF-32 to UTF-16LE/BE transcoding, with or without validation, with and
    without error identification,
  * UTF-16LE/BE to UTF-32 transcoding, with or without validation, with and
    without error identification,
  * From an UTF-8 string, compute the size of the Latin1 equivalent string,
  * From an UTF-8 string, compute the size of the UTF-16 equivalent string,
  * From an UTF-8 string, compute the size of the UTF-32 equivalent string
    (equivalent to UTF-8 character counting),
  * From an UTF-16LE/BE string, compute the size of the Latin1 equivalent
    string,
  * From an UTF-16LE/BE string, compute the size of the UTF-8 equivalent
    string,
  * From an UTF-32 string, compute the size of the UTF-8 or UTF-16LE equivalent
    string,
  * From an UTF-16LE/BE string, compute the size of the UTF-32 equivalent
    string (equivalent to UTF-16 character counting),
  * UTF-8 and UTF-16LE/BE character counting,
  * UTF-16 endianness change (UTF16-LE/BE to UTF-16-BE/LE),
  * WHATWG forgiving-base64 (with or without URL encoding) to binary,
  * Binary to base64 (with or without URL encoding).
 .
 The functions are accelerated using SIMD instructions (e.g., ARM NEON, SSE,
 AVX, AVX-512, RISC-V Vector Extension, LoongSon, POWER, etc.). When your
 strings contain hundreds of characters, we can often transcode them at speeds
 exceeding a billion characters per second. You should expect high speeds not
 only with English strings (ASCII) but also Chinese, Japanese, Arabic, and so
 forth. We handle the full character range (including, for example, emojis).
 .
 The library compiles down to a small library of a few hundred kilobytes. Our
 functions are exception-free and non allocating. We have extensive tests and
 extensive benchmarks.
 .
 This package ships several command line tools.
